
/*
 * File FunctionRelationshipInference.hpp.
 *
 * This file is part of the source code of the software program
 * Vampire as used in CASC-26. It is protected by applicable
 * copyright laws.
 *
 * Posession of, or access to, this program does not
 * give you or anybody else a right or licence to
 * distribute, modify, copy, compile, create derivatives,
 * or use in any form or for any purpose, this program,
 * or any part thereof.
 * Any licence to use Vampire shall only be obtained
 * as described on Vampire's home page http://www.vprover.org.
 *
 * This file was included in the Vampire source code
 * for CASC-26 only because so is required by the CASC-26
 * rules, and for no other reason.
 */


#ifndef __FunctionRelationshipInference__
#define __FunctionRelationshipInference__

#include "Forwards.hpp"



namespace FMB {

using namespace Lib;
using namespace Kernel;

class FunctionRelationshipInference {

public:

void findFunctionRelationships(ClauseIterator clauses, 
                               Stack<DHSet<unsigned>*>& eq_classes, 
                               DHSet<std::pair<unsigned,unsigned>>& nonstrict_cons,
                               DHSet<std::pair<unsigned,unsigned>>& strict_cons); 

private:

ClauseList* getCheckingClauses();

void addClaimForFunction(TermList x, TermList y, TermList fx, TermList fy,
                         unsigned fname,
                         unsigned arg_srt, unsigned ret_srt, Formula::VarList* existential,
                         ClauseList*& newClauses);

void addClaim(Formula* conjecture, ClauseList*& newClauses);
Formula* getName(unsigned fromSort, unsigned toSort, bool strict);

DHMap<unsigned,std::pair<unsigned,unsigned>> _labelMap_nonstrict;
DHMap<unsigned,std::pair<unsigned,unsigned>> _labelMap_strict;

};

}

#endif
