
/*
 * File SpassLiteralSelector.hpp.
 *
 * This file is part of the source code of the software program
 * Vampire as used in CASC-26. It is protected by applicable
 * copyright laws.
 *
 * Posession of, or access to, this program does not
 * give you or anybody else a right or licence to
 * distribute, modify, copy, compile, create derivatives,
 * or use in any form or for any purpose, this program,
 * or any part thereof.
 * Any licence to use Vampire shall only be obtained
 * as described on Vampire's home page http://www.vprover.org.
 *
 * This file was included in the Vampire source code
 * for CASC-26 only because so is required by the CASC-26
 * rules, and for no other reason.
 */



#ifndef __SpassLiteralSelector__
#define __SpassLiteralSelector__

#include "Forwards.hpp"
#include "Lib/SmartPtr.hpp"
#include "Ordering.hpp"

#include "LiteralSelector.hpp"

namespace Kernel {

class SpassLiteralSelector
: public LiteralSelector
{
public:
  CLASS_NAME(SpassLiteralSelector);
  USE_ALLOCATOR(SpassLiteralSelector);

  enum Values {
    OFF = 0,
    IFSEVERALMAXIMAL = 1,
    ALWAYS = 2
  };

  SpassLiteralSelector(const Ordering& ordering, const Options& options, Values value) :
    LiteralSelector(ordering, options), _value(value) {}

  bool isBGComplete() const override { return true; }
protected:
  void doSelection(Clause* c, unsigned eligible);

private:
  LiteralList* getMaximalsInOrder(Clause* c, unsigned eligible);

  Values _value;
};

};

#endif
