
/*
 * File IntNameTable.hpp.
 *
 * This file is part of the source code of the software program
 * Vampire as used in CASC-26. It is protected by applicable
 * copyright laws.
 *
 * Posession of, or access to, this program does not
 * give you or anybody else a right or licence to
 * distribute, modify, copy, compile, create derivatives,
 * or use in any form or for any purpose, this program,
 * or any part thereof.
 * Any licence to use Vampire shall only be obtained
 * as described on Vampire's home page http://www.vprover.org.
 *
 * This file was included in the Vampire source code
 * for CASC-26 only because so is required by the CASC-26
 * rules, and for no other reason.
 */


#ifndef __IntNameTable__
#define __IntNameTable__

#include "Array.hpp"
#include "Map.hpp"
#include "VString.hpp"

using namespace std;

namespace Lib {

class IntNameTable 
{
 public:
  IntNameTable();
  int insert(const vstring& str);




 private:
  Map <vstring,int,Hash> _map;

  int _nextNumber;
}; 

}

#endif
